<?php
add_action('admin_menu', '_onlinecontract_settingspage');

function _onlinecontract_settingspage() {

	add_submenu_page('edit.php?post_type=contract',  __( 'Settings', 'onlinecontract' ),  __( 'Settings', 'onlinecontract' ), 'manage_options', 'contract_settings', 'contract_settings' ); 
	
}

function contract_settings() { 

	/*Get values from previously submitted options*/
	$_onlinecontract_purchaselocation = get_option('onlinecontract_purchaselocation');
	
	$_onlinecontract_purchasecode = get_option('onlinecontract_purchasecode');
	
	$_onlinecontract_businessname = get_option('onlinecontract_businessname');

	$_onlinecontract_adminemail = get_option('onlinecontract_adminemail');
	
	$_onlinecontract_terms = get_option('onlinecontract_contractterms');
	
	$_onlinecontract_currency = get_option('onlinecontract_contractcurrency');
	
	$_onlinecontract_currencytype = get_option('onlinecontract_contractcurrencytype');
	
	$_onlinecontract_emailtemplate = get_option('onlinecontract_emailtemplate');
	
	$_onlinecontract_emailtemplatesubject = get_option('onlinecontract_emailtemplatesubject');
	
	$_onlinecontract_styletemplate = get_option('onlinecontract_styletemplate');

	$_onlinecontract_contractemailfield = get_option('onlinecontract_contractemailfield');

	$_onlinecontract_contractdatetype = get_option('onlinecontract_contractdatetype');

	$i = '';
	$shortcodeselection = array();
	$getcount = get_option('onlinecontract_countcode');
	$shortcodearrcount = '';
	while( $i <= $getcount ) { 
		if(get_option('onlinecontract_shortcode'.$i)) {
			$shortcodearrcount[] = $i;
		}
		$i++;
	} 
		
	if ($shortcodearrcount) {
		foreach( $shortcodearrcount as $i ) {
			$shortcodeselection[] = get_option('onlinecontract_shortcode'.$i);
		}
	}
	
	?>

	<div class="wrap">
		<h2><?php _e( 'Settings', 'onlinecontract' ); ?></h2>
		<?php _onlinecontract_getadminnotification(); ?>
		<div id="onlinecontract-settings">
			<form action="options.php" method="post" name="options" enctype="multipart/form-data">
				<?php echo wp_nonce_field('update-options'); ?>
				<table class="form-table" width="100%" cellpadding="10">
					<tr>
						<th><label for="onlinecontract_purchaselocation"><?php _e( 'Purchased From', 'onlinecontract' ); ?></label></th>
						<td>
							<select name="onlinecontract_purchaselocation" id="onlinecontract_purchaselocation" style="width:97%;">
								<option value="envato"<?php if($_onlinecontract_purchaselocation=='envato') { echo ' selected'; } ?>>CodeCanyon</option>
								<option value="fdg"<?php if($_onlinecontract_purchaselocation=='fdg') { echo ' selected'; } ?>>Future Design Group</option>
							</select>
						<br><small><?php _e( 'Where did you purchase this plugin?', 'onlinecontract' ); ?></small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_purchasecode"><?php _e( 'Purchase Code', 'onlinecontract' ); ?></label></th>
						<td><input type="text" name="onlinecontract_purchasecode" id="onlinecontract_purchasecode" value="<?php echo $_onlinecontract_purchasecode; ?>" size="30" style="width:97%;"><br><small><?php _e( 'Enter your purchase code.', 'onlinecontract' ); ?>
						<br>
						<?php if(_onlinecontract_validate_purchase(get_option('onlinecontract_purchasecode'), get_option('onlinecontract_purchaselocation'))) { ?>
						<span style="color:green;"><?php _e( 'Your code is valid.  Thanks for purchasing our plugin.', 'onlinecontract' ); ?></span>
						<?php }else{ ?>
						<span style="color:red;"><?php _e( 'If you purchased from CodeCanyon please retrieve this code from your downloads page. If you purchased directly from us, please see the email that was sent to you. If you did not purchase this plugin, please visit <a href="http://codecanyon.net/item/wp-online-contract/7698011?ref=futuredesigngrp" target="_blank">CodeCanyon</a> to purchase', 'onlinecontract' ); ?></span>
						<?php } ?></small></td>
					</tr>
					<?php if(_onlinecontract_validate_purchase(get_option('onlinecontract_purchasecode'), get_option('onlinecontract_purchaselocation'))) { ?>
					<tr>
						<th><label for="onlinecontract_businessname"><?php _e( 'Your Company Name', 'onlinecontract' ); ?></label></th>
						<td><input type="text" name="onlinecontract_businessname" id="onlinecontract_businessname" value="<?php echo $_onlinecontract_businessname; ?>" size="30" style="width:97%;"><br><small><?php _e( 'Enter the name of your company that will display on the contract.', 'onlinecontract' ); ?></small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_adminemail"><?php _e( 'Administration Email Notification', 'onlinecontract' ); ?></label></th>
						<td><input type="text" name="onlinecontract_adminemail" id="onlinecontract_adminemail" value="<?php if($_onlinecontract_adminemail) { echo $_onlinecontract_adminemail; }else{ echo get_option( 'admin_email' ); } ?>" size="30" style="width:97%;"><br><small><?php _e( 'Enter the email address you want status emails to be directed to.', 'onlinecontract' ); ?></small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_contractcurrency"><?php _e( 'Currency Symbol', 'onlinecontract' ); ?></label></th>
						<td><input type="text" name="onlinecontract_contractcurrency" id="onlinecontract_contractcurrency" value="<?php if($_onlinecontract_currency) { echo $_onlinecontract_currency; }else{ '$'; } ?>" size="30" style="width:50%;"><br><small><?php _e( 'Enter your current symbol.' ); ?> (ex: $ or &euro;, etc)</small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_contractcurrencytype"><?php _e( 'Currency Type', 'onlinecontract' ); ?></label></th>
						<td><input type="text" name="onlinecontract_contractcurrencytype" id="onlinecontract_contractcurrencytyle" value="<?php if($_onlinecontract_currencytype) { echo $_onlinecontract_currencytype; }else{ echo 'USD'; } ?>" size="30" style="width:50%;"><br><small><?php _e( 'Enter your currency type.' ); ?> (ex: USD or EUR, etc)
	 <?php _e( 'A complete list can be found' ); ?> <a href="https://developer.paypal.com/docs/classic/api/currency_codes/" target="_blank" onclick="return makesureSave();"><?php _e( 'here' ); ?></a></small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_contractdatetype"><?php _e( 'Date Format', 'onlinecontract' ); ?></label></th>
						<td><input type="text" name="onlinecontract_contractdatetype" id="onlinecontract_contractdatetype" value="<?php if($_onlinecontract_contractdatetype) { echo $_onlinecontract_contractdatetype; }else{ echo 'm/d/Y'; } ?>" size="30" style="width:50%;"><br><small><?php _e( 'Enter the format in which you want to enter a date. You can find more information about date formats.' ); ?> <a href="http://php.net/manual/en/function.date.php" target="_blank" onclick="return makesureSave();"><?php _e( 'here' ); ?></a>.</small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_contractemailfield"><?php _e( 'Shortcode For Client\'s Email', 'onlinecontract' ); ?></label></th>
						<td><select name="onlinecontract_contractemailfield" id="onlinecontract_contractemailfield" style="width:97%;">
								<?php
									foreach ($shortcodeselection as $shortcodeemailselection) {
										echo '<option value='.$shortcodeemailselection;
										if($shortcodeemailselection == $_onlinecontract_contractemailfield) {
											echo ' selected';
										}
										echo '>'.$shortcodeemailselection.'</option>';

									}
								?>
							</select><br><small><?php _e( 'Select the shortcode used for the client\'s email address. This will be used to allow the client to view their contracts using their email address.', 'onlinecontract'); ?></small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_contractemailpage"><?php _e( '[emaillist] Page Location', 'onlinecontract' ); ?></label></th>
						<td>
							<?php
							$arg = array(
							'name' => 'onlinecontract_contractemailpage',
							'selected' => get_option('onlinecontract_contractemailpage'),
							);
							wp_dropdown_pages($arg);
							?>
							<br><small><?php _e( 'Select the page where you added the [emaillist] shortcode to display client contracts', 'onlinecontract'); ?></small>
						</td>
					</tr>
					<?php
				    
				    ?>

					<?php } ?>
				</table>
				<input type="hidden" name="action" value="update" />
				<?php if(_onlinecontract_validate_purchase(get_option('onlinecontract_purchasecode'), get_option('onlinecontract_purchaselocation'))) { ?>
				<input type="hidden" name="page_options" value="onlinecontract_adminemail,onlinecontract_contractdatetype,onlinecontract_purchaselocation,onlinecontract_purchasecode,onlinecontract_businessname,onlinecontract_contractcurrency,onlinecontract_contractcurrencytype,onlinecontract_contractemailfield,onlinecontract_contractemailpage" />
				<?php }else{ ?>
				<input type="hidden" name="page_options" value="onlinecontract_purchaselocation,onlinecontract_purchasecode," />
				<?php } ?>
				<input type="submit" name="btnupdatesettings" id="btnupdatesettings" value="<?php _e( 'Update Settings', 'onlinecontract' ); ?>" class="button-primary" />
			</form>
		</div>
		<div id="onlinecontract-infotext">
			<a href="http://codecanyon.net/item/wp-online-contract/7698011?ref=futuredesigngrp" target="_blank" onclick="return makesureSave();"><img src="<?php echo plugins_url( 'img/wp-online-contractlogo-small.png', __FILE__ ); ?>" style="max-width:512px; width:100%; height:auto; border:0px;"></a>
			<hr>
			<p><?php _e( 'Thank you for using our Online Contract plugin. We hope our plugin gives you as much use as we have found in it.  Please rate this plugin if you like how it functions and if it helps you create unique, usable contracts that help you keep track of signatures and clients.', 'onlinecontract' ); ?></p>
			<p><?php _e( 'You can rate our plugin and view other reviews using the following link through CodeCanyon in your downloads', 'onlinecontract' ); ?>:<br><a href="http://codecanyon.net/downloads?ref=futuredesigngrp" target="_blank">http://codecanyon.com/downloads</a></p>
			<p><?php _e( 'Interested in more of our plugins?  Please take a look at our CodeCanyon portfolio for all of our plugins and code', 'onlinecontract' ); ?>:<br><a href="http://codecanyon.net/user/futuredesigngrp/portfolio?ref=futuredesigngrp" target="_blank">http://codecanyon.net/user/futuredesigngrp/portfolio</a></p>
			<p><?php _e( 'See this plugin\'s full documentation online using the following URL', 'onlinecontract' ); ?>:<br>
			<a href="http://onlinecontract.futuredesigngroup.com/documentation/" target="_blank">http://onlinecontract.futuredesigngroup.com/documentation/</a>
			</p>
			<div style="width:100%;">
			<hr>
			<?php
			echo _onlinecontract_get_envato_profile();
			?>
			</div>
			<div style="float:right; padding-top:8px; width: 40%; text-align: right;"><?php _e( 'Version', 'onlinecontract' ); ?> <?php echo _onlinecontract_version_num; ?> </div>
			<div style="clear:both; float:none;"></div>
		</div>
		<div id="onlinecontract-settings">
			<?php if(_onlinecontract_validate_purchase(get_option('onlinecontract_purchasecode'), get_option('onlinecontract_purchaselocation'))) { ?>
				<h3><?php _e( 'Advanced Usage', 'onlinecontract' ); ?></h3>
				<hr>
				<p><?php _e( 'Want to spice up our plugin with user client initiation or user accounts?  Use the following shortcodes to add items to your website with ease.  You can customize these shortcodes more on your shortcodes page if required.', 'onlinecontract' ); ?></p>
				<p><?php _e( 'If you would like to give your clients the opportunity to initiate a contract, you can easily add the following shortcode to any page or theme file', 'onlinecontract' ); ?>:<br>
				<strong><span style="color: white; background-color: green; border-radius: 3px; padding: 2px 5px; font-size:14px;">[clientadd]</span></strong></p>
				<p><?php _e( 'This will add a short form that can be styled by you that will allow a client to create a pending contract and send your administrative contact an email notification.', 'onlinecontract' ); ?></p>
				<hr>
				<p><?php _e( 'If you would like to display a list of contracts for a user\'s email address, you can easily add the following shortcode to any page or theme file', 'onlinecontract' ); ?>:<br>
				<strong><span style="color: white; background-color: green; border-radius: 3px; padding: 2px 5px; font-size:14px;">[emaillist]</span></strong></p>
				<p><?php _e( 'Once you have added the shortcode to a page, you select the page above to force all user links to point to this page. If they have an account, the page will populate within their profile and dashboard.', 'onlinecontract' ); ?></p>
				<p><?php _e( 'If they do not have an account, you can link them directly to their page using the following format:' ); ?><br><em><a href="<?php echo get_page_link(get_option('onlinecontract_contractemailpage'))?>?email=email@domain.com" target="_blank"><?php echo get_page_link(get_option('onlinecontract_contractemailpage'))?>?email=email@domain.com</a></em><br><?php _e( 'Just replace the email with their email address.' ); ?></p>
				<p><?php _e( 'You can style this list using the following class:' ); ?><br><em>.contractlistitem</em></p>
			<?php }else{ ?>
				<p style="text-align:center;"><?php _e( 'Please enter your purchase code and purchase location before continuing with this plugin.', 'onlinecontract' ); ?></p>

			<?php } ?>
		</div>	
	</div>
<?php } ?>