<?php

add_action('admin_menu', '_onlinecontract_contract_templatespage');



function _onlinecontract_contract_templatespage() {



	add_submenu_page('edit.php?post_type=contract',  __( 'Contract Templates', 'onlinecontract' ),  __( 'Contract Templates', 'onlinecontract' ), 'manage_options', 'contract_templates', 'contract_templates' ); 

	

}



function contract_templates() { 

	if(isset($_GET['contract'])) {
		$upload_dir = wp_upload_dir();
		if(file_exists($upload_dir['basedir'].'/onlinecontract/contracts/'.$_GET['contract'].'.txt')) {
		$file = file_get_contents($upload_dir['basedir'].'/onlinecontract/contracts/'.$_GET['contract'] . ".txt", "r");
		}
		$contractname = ucwords(str_replace('-',' ', $_GET['contract']));

	}

?>

	<div class="wrap">

		<h2><?php _e( 'Contract Templates', 'onlinecontract' ); ?></h2>

		<?php _onlinecontract_getadminnotification(); ?>

		<form action="options.php" method="post" name="options" enctype="multipart/form-data">

			<?php echo wp_nonce_field('update-options'); ?>

			<div id="onlinecontract-settings">

				<h3>Create or Edit A Contract</h3>

				<hr>

				<p>Use this page to created or edit contracts for your WP Online Contract usage. You can modify or create a contract using WordPress's built in editor or if you know how to use HTML code, you can use the code view.  If you need help with the shortcode usage, please see our guide at the bottom of the page.</p>

				<?php

					if ($file!= '' || !isset($_GET['contract'])) {

						echo '<table class="form-table" width="100%" cellpadding="10">

						<tbody>

						<tr>

						<th style="width:15%"><label for="onlinecontract_contractname">Contract Name</label></th>';

						if($contractname) {

							echo '<td><input type="text" name="onlinecontract_contractname" id="onlinecontract_contractname" value="' . stripslashes($contractname). '" size="30" style="width:90%;" required disabled><br>Current name (this is not editable because changing it will alter all contracts using this it)</td>';

						}else{

							echo '<td><input type="text" name="onlinecontract_contractname" id="onlinecontract_contractname" value="' . stripslashes($contractname). '" size="30" style="width:90%;"><br>Enter the name of this contract</td>';

						}

						echo '</tr>

						</tbody>

						</table>';

					}

				?>

			</div>

			<div id="onlinecontract-infotext">

				<h3>Need To Edit An Existing Contract...</h3>

				<hr>

				<p>Choose from your existing contracts below.  Remember, this choice will refresh the page and you will lose changes to what you are working on.  Save your current edits or new editions using the "Save Changes" button on the top right.</p>

				<div style="width:98%; float:left; line-height:28px; background-color:#f8f8f8; padding:1%; margin-bottom:5px; text-align:right;"><input type="button" class="button-delete" onclick="if (makesureSave()) { window.open('edit.php?post_type=contract&page=contract_templates', '_self')};" value="Create New"></div>

				<?php
				$upload_dir = wp_upload_dir(); 
				if(showContentEditSelect($upload_dir['basedir'] .'/onlinecontract/contracts/')) {
					echo showContentEditSelect($upload_dir['basedir'] .'/onlinecontract/contracts/');
					echo '<br><label>Remove contract templates by checking their box (existing contracts with this template will no longer be usable).<br>You can view their source code using the button to the right to copy and create your own contracts.</label><br><br>';

				}else{

					echo '<label>There are no contracts.  Use our [shortcodes] to the right and create your own.</label><br><br>';

				}

				?>

				<h3>...Or Upload A New Contract?</h3>

				<label for="file">Select a file:</label> <input type="file" name="userfile" id="userfile">

				<p>Upload your contract template file (only txt files can be uploaded)</p>

				<input type="submit" name="btnupdatecontracts" id="btnupdatecontracts" value="Update Contracts" class="button-primary" onclick="return makesureDelete();" style="margin-top:30px;">

			</div>

			<?php

				if ($file!= '' || !isset($_GET['contract'])) {

					$content = $file;

					wp_editor( wpautop(stripslashes($content)), 'editcontract' );

				}else{

					echo '<div id="onlinecontract-settings" style="line-height: 400px; text-align: center; min-height:700px;">The contract you selected, does not exist.  Please select another contract from the list below to continue.</div>';

				}

			?>

			<div id="onlinecontract-infotext">

				<h3>Contract Shortcodes</h3>

				<hr>

				<div style="overflow-y:scroll; height:400px;">

					<?php 

						$shortcodearr = _onlinecontract_getallshortcodes();

						if($shortcodearr) {

							foreach ($shortcodearr as $shortcode) {

								echo '<p><strong>'.$shortcode['shortcode'].'</strong>';

								if($shortcode['isfunction']=='') {

									echo '<br>'.$shortcode['description'].'</p>';

								}else{

									echo '<br><em>'.__( 'Used as a function').'</em> ( <strong>'.$shortcode['functionstring'].'</strong> )</p>';

								}

							}

						}else{

							_e( 'In order to customize this contract, you must add shortcodes.  You can do this by visiting the "Shortcodes" link on the left.', 'onlinecontract' );

						}

					?>

				</div>

			</div>

			<div id="onlinecontract-settings">

				<input type="hidden" name="action" value="update">

				<input type="hidden" name="page_options" value="">

				<p style="text-align:center;">If you click Save Changes and nothing happens, try switching to visual from text or vice versa then resubmit.  This usually fixes this issue.</p>

				<div style="float:right;"><?php _e( 'Version', 'onlinecontract' ); ?> <?php echo _onlinecontract_version_num; ?></div> 

				<input type="button" name="btneditcontracts" id="btneditcontracts" value="Save Changes" class="button-primary">

			</div>			

		</form>

	</div>

	<script>

	var $ = jQuery;

	$(document).ready(function(){     

			$("#btneditcontracts").click(function(e){ 

				var dataString = "";

				var content = tinyMCE.activeEditor.getContent();

				var title = $("#onlinecontract_contractname").val();

				dataString = "title=" + title + "&contract=" + encodeURIComponent(content);

	 

				$.ajax({

					type: "POST",

					url: "<?php echo plugins_url(); ?>/onlinecontract/includes/editcontract.php",

					data: dataString,

					success: function(data) {
						window.location.reload(true);

					}

				});

				return false;

			console.log(datastring);

			});

	});

	</script>

<?php } ?>