<?php
/*
error_reporting(E_ALL);
ini_set('display_errors', 1);*/

/* Create required folders and upload demo contracts is they do not exist */
$upload_dir = wp_upload_dir();
$contractpath = $upload_dir['basedir'].'/onlinecontract/';
$contractcontractspath = $upload_dir['basedir'].'/onlinecontract/contracts/';
$contractsignaturespath = $upload_dir['basedir'].'/onlinecontract/signatures/';
if(!is_dir($contractpath)){

    mkdir($contractpath);
	
}

if(!is_dir($contractcontractspath)){

    mkdir($contractcontractspath);

	$src = plugin_dir_path(__FILE__).'democontracts/';
	recurse_copy($src,$contractcontractspath);
	
}

if(!is_dir($contractsignaturespath)){
    
	mkdir($contractsignaturespath);
	
}

function recurse_copy($src,$dst) {
    
	$dir = opendir($src); 
    @mkdir($dst); 
    while(false !== ( $file = readdir($dir)) ) { 
        if (( $file != '.' ) && ( $file != '..' )) { 
            if ( is_dir($src . '/' . $file) ) { 
                recurse_copy($src . '/' . $file,$dst . '/' . $file); 
            } 
            else { 
                copy($src . '/' . $file,$dst . '/' . $file); 
            } 
        } 
    } 
    closedir($dir); 
	
}

/* Initialize plugin */
function _onlinecontract_init() {
	add_option( 'onlinecontract_validated', 0, '', 'no' );
	if(_onlinecontract_validate_purchase(get_option('onlinecontract_purchasecode'), get_option('onlinecontract_purchaselocation'))) {
	
		$_onlinecontract_labels = array( 
			'name'               => _x( __( 'Online Contract', 'onlinecontract' ), 'contract' ),
			'singular_name'      => _x( __( 'Contract', 'onlinecontract' ), 'contract' ),
			'add_new'            => _x( __( 'Add New', 'onlinecontract' ), 'contract' ),
			'add_new_item'       => _x( __( 'Add New Contract', 'onlinecontract' ), 'contract' ),
			'edit_item'          => _x( __( 'Edit Contract', 'onlinecontract' ), 'contract' ),
			'new_item'           => _x( __( 'New Contract', 'onlinecontract' ), 'contract' ),
			'view_item'          => _x( __( 'View Contract', 'onlinecontract' ), 'contract' ),
			'search_items'       => _x( __( 'Search Contracts', 'onlinecontract' ), 'contract' ),
			'not_found'          => _x( __( 'No contracts found', 'onlinecontract' ), 'contract' ),
			'not_found_in_trash' => _x( __( 'No contracts found in trash', 'onlinecontract' ), 'contract' ),
			'parent_item_colon'  => _x( __( 'Parent Contract:', 'onlinecontract' ), 'contract' ),
			'menu_name'          => _x( __( 'Contracts', 'onlinecontract' ), 'contract' ),
		);
		$_onlinecontract_args = array( 
			'menu_icon'           => '',
			'labels'              => $_onlinecontract_labels,
			'hierarchical'        => false,
			'description'         => __( 'Create a contract and allow your clients to view, sign, and download a PDF version.', 'onlinecontract' ),
			'supports'            => array( 'title', 'revisions' ),
			'taxonomies'          => array('' ),
			'public'              => true,
			'show_ui'             => true,
			'show_in_menu'        => true,
			'show_in_nav_menus'   => true,
			'show_in_admin_bar'   => true,
			'publicly_queryable'  => true,
			'exclude_from_search' => false,
			'has_archive'         => false,
			'query_var'           => true,
			'can_export'          => true,
			'rewrite'             => true,
			'capability_type'     => 'post'
		);
		
		
		
		/* Add default menu items to plugin sub menu */
		include( 'paypal.php' );
		include( 'contract-settings.php' );
		include( 'shortcodes.php' );	
		include( 'templates.php' );	
		include( 'edit-contracts.php' );

		add_filter( 'plugin_action_links', '_onlinecontract_plugin_action_links', 10, 2 );
		add_filter( 'plugin_action_links', '_onlinecontract_plugin_action_links_documentation', 10, 2 );		

		register_post_type( 'contract', $_onlinecontract_args );
	}else{

		add_filter( 'plugin_action_links', '_onlinecontract_plugin_action_links', 10, 2 );
		add_filter( 'plugin_action_links', '_onlinecontract_plugin_action_links_documentation', 10, 2 );
		
		$_onlinecontract_labels = array( 
			'name'               => _x( __( 'Online Contract', 'onlinecontract' ), 'contract' ),
			'singular_name'      => _x( __( 'Contract', 'onlinecontract' ), 'contract' ),
			'add_new'            => _x( __( 'Add New', 'onlinecontract' ), 'contract' ),
			'add_new_item'       => _x( __( 'Add New Contract', 'onlinecontract' ), 'contract' ),
			'edit_item'          => _x( __( 'Edit Contract', 'onlinecontract' ), 'contract' ),
			'new_item'           => _x( __( 'New Contract', 'onlinecontract' ), 'contract' ),
			'view_item'          => _x( __( 'View Contract', 'onlinecontract' ), 'contract' ),
			'search_items'       => _x( __( 'Search Contracts', 'onlinecontract' ), 'contract' ),
			'not_found'          => _x( __( 'No contracts found', 'onlinecontract' ), 'contract' ),
			'not_found_in_trash' => _x( __( 'No contracts found in trash', 'onlinecontract' ), 'contract' ),
			'parent_item_colon'  => _x( __( 'Parent Contract:', 'onlinecontract' ), 'contract' ),
			'menu_name'          => _x( __( 'Contracts', 'onlinecontract' ), 'contract' ),
		);
		
		$_onlinecontract_args = array( 
			'menu_icon'           => '',
			'labels'              => $_onlinecontract_labels,
			'hierarchical'        => false,
			'description'         => __( 'Create a contract and allow your clients to view, sign, and download a PDF version.', 'onlinecontract' ),
			'supports'            => array( 'title', 'revisions' ),
			'taxonomies'          => array('' ),
			'public'              => true,
			'show_ui'             => true,
			'show_in_menu'        => true,
			'show_in_admin_bar'   => true,
			'show_in_nav_menus'   => true,
			'publicly_queryable'  => true,
			'exclude_from_search' => false,
			'has_archive'         => false,
			'query_var'           => true,
			'can_export'          => true,
			'rewrite'             => true,
			'capability_type'     => 'post'
		);
		
		register_post_type( 'contract', $_onlinecontract_args );
		
		/* Add default menu items to plugin sub menu */
		include( 'contract-settings.php' );	
		add_filter( 'menu_order', 'remove_those_menu_items' );
		add_filter( 'custom_menu_order' , '__return_true', 999);
				
	}
}

/* Flush URL rules on plugin load */
function _onlinecontract_rewrite_flush() {
    _onlinecontract_init();
    flush_rewrite_rules();
}

register_activation_hook( __FILE__, '_onlinecontract_rewrite_flush' );

/* Include single contract template */
add_filter( 'template_include','_onlinecontract_include_template_function', 1 );

/* If post type is contract, find single template */
function _onlinecontract_include_template_function( $template_path ) {
	
	if ( get_post_type() == 'contract' ) {
		if ( is_single() ) {
			if ( $theme_file = locate_template( array( 'single-contract.php' ) ) ) {
				$template_path = $theme_file;
			} else {
				$template_path = plugin_dir_path( __FILE__ ) .'single-contract.php';
			}
		}
	}
	return $template_path;

}

function _onlinecontract_getallshortcodes() {
	
	$i = '';
    $prefix = '_onlinecontract_';
	$shortcodearrcount = array();
	$shortcodeselection = array();
	$getcount = get_option('onlinecontract_countcode');
	while( $i <= $getcount ) { 
		if(get_option('onlinecontract_shortcode'.$i)) {
			$shortcodearrcount[] = $i;
		}
		$i++;
	} 
	$shortcodearr = array();
	$shortcodearr[] = array(
				'shortcode'      => '[contractcurrency]',
				'description'    => 'Displays the currency symbol you set in your settings page (ex: $ or &euro;)',
				'isfunction'     => '',
				'functionstring' => ''
				);
	$shortcodearr[] = array(
				'shortcode'      => '[businessname]',
				'description'    => 'Displays the business name you set in your settings page',
				'isfunction'     => '',
				'functionstring' => ''
				);
	
	if ($shortcodearrcount) {	
		foreach( $shortcodearrcount as $i ) {
			$shortcodearr[] = array(
				'shortcode'      => get_option('onlinecontract_shortcode'.$i),
				'description'    => get_option('onlinecontract_shortcodedesc'.$i),
				'isfunction'     => get_option('onlinecontract_shortcodefunctiononly'.$i),
				'functionstring' => get_option('onlinecontract_shortcodefunction'.$i)
			);
		}
	}
	
	return $shortcodearr;
}

/* Add custom shortcodes to contract entry page */
function _onlinecontract_metaboxes( $meta_boxes ) {
	
	$i = '';
    $prefix = '_onlinecontract_';
	$shortcodearr = array();
	$shortcodearrcount = array();
	$shortcodeselection = array();
	$getcount = get_option('onlinecontract_countcode');
	while( $i <= $getcount ) { 
		if(get_option('onlinecontract_shortcode'.$i)) {
			$shortcodearrcount[] = $i;
		}
		$i++;
	} 
	$upload_dir = wp_upload_dir();
	$templates = str_replace('.txt','',showContent($upload_dir['basedir'].'/onlinecontract/contracts'));
	$templates = explode('<br>',$templates);
	$templatesarr = array();
	foreach($templates as $template) {
		if($template !=''){
			$templatesarr[$template] = ucwords(str_replace('_',' ',str_replace('-',' ',$template)));
		}

	}
	$shortcodepaymentselection['none'] = __( 'Do not display payment options', 'onlinecontract' );
	if ($shortcodearrcount) {
		foreach( $shortcodearrcount as $i ) {
			$shortcodepaymentselection[get_option('onlinecontract_shortcode'.$i)] = get_option('onlinecontract_shortcode'.$i);
		}
	}
	
	if ($shortcodearrcount) {
		foreach( $shortcodearrcount as $i ) {
			$shortcodeselection[get_option('onlinecontract_shortcode'.$i)] = get_option('onlinecontract_shortcode'.$i);
		}
	}
	
	$defaultoptions = array(
		array( 
			'name'    => __( 'Contract Type', 'onlinecontract' ), 
			'desc'    => __( 'Select one of the contract templates you have created', 'onlinecontract' ), 
			'id'      => $prefix . 'contracttype',
			'type'    => 'select',
			'options' => $templatesarr
		),
		array( 
			'name'    => __( 'Shortcode for Payment Amount', 'onlinecontract' ), 
			'desc'    => __( 'Select a shortcode to pass as the payment amount', 'onlinecontract' ), 
			'id'      => $prefix . 'contractpayment',
			'type'    => 'select',
			'options' => $shortcodepaymentselection
		),
		array( 
			'name'    => __( 'Shortcode for Payment Item Name', 'onlinecontract' ), 
			'desc'    => __( 'Select a shortcode to pass as the payment item name', 'onlinecontract' ), 
			'id'      => $prefix . 'contractpaymentitemname',
			'type'    => 'select',
			'options' => $shortcodeselection
		),
		array( 
			'name'    => __( 'Shortcode for Your Representative', 'onlinecontract' ), 
			'desc'    => __( 'Select a shortcode to pass who from your company will sign this contract (displayed on the main page)', 'onlinecontract' ), 
			'id'      => $prefix . 'selectedrep',
			'type'    => 'select',
			'options' => $shortcodeselection
		),
		array( 
			'name'    => __( 'Redirect to a New Page When Signed', 'onlinecontract' ).'?', 
			'desc'    => __( 'If not, please leave blank or use the following input type', 'onlinecontract' ).': (ex: http://example.com)', 
			'id'      => $prefix . 'contractredirect',
			'type'    => 'text'
		),
		array( 
			'name'    => __( 'Remove Signature Box', 'onlinecontract' ).'?', 
			'desc'    => __( 'Check to remove signature window and just display print and payment options', 'onlinecontract' ), 
			'id'      => $prefix . 'contractshowsignature',
			'type'    => 'checkbox'
		),
		array( 
			'name'    => __( 'Send Notification to Client', 'onlinecontract' ).'?', 
			'desc'    => __( 'Check to automatically send an email to the client when the contract is created.', 'onlinecontract' ), 
			'id'      => $prefix . 'contractsendnotification',
			'type'    => 'checkbox'
		),
		array( 
			'name'    => __( 'Shortcode for Client Email', 'onlinecontract' ), 
			'desc'    => __( 'Select a shortcode to pass as the client email address', 'onlinecontract' ), 
			'id'      => $prefix . 'contractpaymentclientemail',
			'type'    => 'select',
			'options' => $shortcodeselection
		)
	);
	
	if ($shortcodearrcount) {	
		foreach( $shortcodearrcount as $i ) {
				if( get_option('onlinecontract_shortcodefunctiononly'.$i) != 'on' ) {
					
					$selectoptionsexarr = array();
					$selectoptionarr = array();
					if (get_option('onlinecontract_shortcodevisiblefront') == 'on') {
						echo 'here';
					}
					if(get_option('onlinecontract_shortcodetype'.$i) == 'select') {
						if(get_option('onlinecontract_shortcodeoptions'.$i)=='getusersemail') {
							$blogusers = get_users( 'role=subscriber&orderby=email&order=ASC&number=500' );
							foreach ( $blogusers as $user ) {
								$selectoptionarr[esc_html( $user->user_email )] = ucwords(esc_html( $user->display_name ));
							}

							$shortcodearr[] =  array( 
								'name'    => get_option('onlinecontract_shortcodename'.$i), 
								'desc'    => get_option('onlinecontract_shortcodedesc'.$i), 
								'id'      => $prefix . str_replace(']','',str_replace('[','',get_option('onlinecontract_shortcode'.$i))),
								'type'    => 'select',
								'options' =>$selectoptionarr
							);

						}else{
							$selectoptionsexarr = explode(', ',trim(get_option('onlinecontract_shortcodeoptions'.$i)));

							if ($selectoptionsexarr) {
								foreach( $selectoptionsexarr as $selectoption ) {
									$selectoptionarr[$selectoption] = $selectoption;
								}
							}

							$shortcodearr[] =  array( 
								'name'    => get_option('onlinecontract_shortcodename'.$i), 
								'desc'    => get_option('onlinecontract_shortcodedesc'.$i), 
								'id'      => $prefix . str_replace(']','',str_replace('[','',get_option('onlinecontract_shortcode'.$i))),
								'type'    => 'select',
								'options' =>$selectoptionarr
							);
						}

					}else{
						
						$shortcodearr[] =  array( 
							'name'    => get_option('onlinecontract_shortcodename'.$i), 
							'desc'    => get_option('onlinecontract_shortcodedesc'.$i), 
							'id'      => $prefix . str_replace(']','',str_replace('[','',get_option('onlinecontract_shortcode'.$i))),
							'type'    => get_option('onlinecontract_shortcodetype'.$i)
						);

					}

				}
			}
	}else{
		$shortcodearr[] = array(
			'desc'   => __( 'In order to customize this contract, you must add shortcodes.  You can do this by visiting the "Shortcodes" link on the left.', 'onlinecontract' ),
			'type'   => 'title',
			'id'     => $prefix . '_onlinecontract_noshortcodes'
		);
	}
	
	$meta_boxes['_onlinecontract_default'] = array(
        'id'         => '_onlinecontract_default',
        'title'      => __( 'Default Options', 'onlinecontract' ),
        'pages'      => array('contract'),
        'context'    => 'normal',
        'priority'   => 'high',
        'show_names' => true,
        'fields'     => $defaultoptions,
    );
	
    $meta_boxes['_onlinecontract_metabox'] = array(
        'id'         => '_onlinecontract_metabox',
        'title'      => __( 'Custom Options', 'onlinecontract' ),
        'pages'      => array('contract'),
        'context'    => 'normal',
        'priority'   => 'high',
        'show_names' => true,
        'fields'     => $shortcodearr,
    );
	
	$meta_boxes['_onlinecontract_signature'] = array(
        'id'         => '_onlinecontract_signature',
        'title'      => __( 'Contract Status', 'onlinecontract' ),
        'pages'      => array('contract'),
        'context'    => 'side',
        'priority'   => 'high',
        'show_names' => true,
        'fields'     => array(
							array(
								'id'   => 'contractcomplete',
								'type' => 'checkboxsigned'
							)
						)
    );

    return $meta_boxes;
}

/* Initialize Custom Meta Box functionality */

function _onlinecontract_init_meta_boxes() {
    if ( !class_exists( 'cmb_Meta_Box' ) ) {
        require_once( 'cmb/init.php' );
    }
}

/* Get all contract templates */
function showContent( $path ){
	$dirlisting = '';
	if ( $handle = opendir( $path ) ) {
	   while ( false !== ( $file = readdir( $handle ) ) )
	   {
		   if ( $file != "." && $file != ".." )
		   {
			   $fName  = $file;
			   $file   = $path.'/'.$file;
			   $ext = pathinfo( $file, PATHINFO_EXTENSION );
			   if( is_file($file) && $ext =='txt' ) {
				   $dirlisting .= $fName.'<br>';
			   }
		   }
	   }

	   closedir( $handle );
	}  

return $dirlisting;
}
/* Get all contract templates for edit window */
function showContentEditSelect($path){
	$dirlisting = '';
	if ($handle = opendir($path))
	{
	   while (false !== ($file = readdir($handle)))
	   {
		   if ($file != "." && $file != "..")
		   {
			   $fName  = $file;
			   $file   = $path.'/'.$file;
			   $ext = pathinfo($file, PATHINFO_EXTENSION);
			   if(is_file($file) && $ext =='txt') {
					$dirlisting .= '
					<div style="width:48%; float:left; line-height:28px; background-color:#f8f8f8; padding:1%; margin-bottom:5px;">
						<input type="checkbox" name="file[]" value="'.$file.'" />'.$fName.'
					</div>
					<div style="width:48%; float:left; text-align:right; background-color:#f4f4f4; padding:1%; margin-bottom:5px;">
						<input type="button" class="button-success" onclick="if (makesureSave()) { window.open(\'edit.php?post_type=contract&page=contract_templates&contract='.str_replace('.txt','',$fName).'\', \'_self\')};" value="Edit This Contract"> 
						<input type="button" class="button-secondary" onclick="window.open(\''.content_url().'/uploads/onlinecontract/contracts/'.$fName.'\',\'_blank\')" value="View Source Code">
					</div> ';
			   }
			   
		   }
	   }
	   closedir($handle);
	}  
return $dirlisting;
}

/* Convert shortcodes to text */
function convertcontractshortcode( $contractinput ) {
	$shortcodearrcount = array();
	$shortcodearr = array();
	$i = 0;
	$getcount = get_option('onlinecontract_countcode');
	while( $i <= $getcount ) { 
		if(get_option('onlinecontract_shortcode'.$i)) {
			$shortcodearrcount[] = $i;
		}
		$i++;
	} 
	
	if ($shortcodearrcount) {	
		foreach( $shortcodearrcount as $i ) {
			$shortcodearr[] =  array( 
				'shortcode'     => get_option('onlinecontract_shortcode'.$i), 
				'function'      => get_option('onlinecontract_shortcodefunction'.$i) );
		}
	}
	$contract = $contractinput;
	if($shortcodearr) {
		foreach ($shortcodearr as $shortcode) {
			$shortcodename = str_replace(']','',str_replace('[','',$shortcode['shortcode']));
			if (strpos($contractinput,$shortcode['shortcode']) !== false) {
				if($shortcode['function']) {
					preg_match_all("/\[[^\]]*\]/", $shortcode['function'], $matches);
					$entirefunction = $shortcode['function'];
					foreach ($matches[0] as $functionshortcode) {
						$extractedshortcode = str_replace(']','',str_replace('[','',$functionshortcode));
						$shortcodeextractedvalue = get_post_meta( get_the_ID(), '_onlinecontract_'.$extractedshortcode.'', true );
						$entirefunction = str_replace($functionshortcode,$shortcodeextractedvalue,$entirefunction);
					}
					$shortcodevalue = calc_string($entirefunction);
				}else{
					$shortcodevalue = get_post_meta( get_the_ID(), '_onlinecontract_'.$shortcodename.'', true );
				}
				$contract = str_replace($shortcode['shortcode'],$shortcodevalue,$contract);
			}
		}
	}
	
	/* Default Shortcodes */
	if (strpos($contractinput,'[businessname]') !== false) {
		if(isset($_GET['pdf']) && $_GET['pdf']==1) {
			$contract = str_replace('[businessname]',get_option('onlinecontract_businessname').'  ',$contract);
		}else{
			$contract = str_replace('[businessname]',get_option('onlinecontract_businessname'),$contract);
		}
	}
	if (strpos($contractinput,'[contractcurrency]') !== false) {
		$contract = str_replace('[contractcurrency]',get_option('onlinecontract_contractcurrency'),$contract);
	}
	if (strpos($contractinput,'[contract-link]') !== false) {
		$contract = str_replace('[contract-link]','<a href="'.get_permalink(get_the_ID()).'">'.get_permalink(get_the_ID()).'</a>',$contract);
	}
	return $contract;
}

/* Convert shortcode functions to math calculations */
function calc_string( $mathString )
{
	$cf_DoCalc = create_function("", "return (" . $mathString . ");" );
	
	return $cf_DoCalc();
};

function remove_those_menu_items( $menu_order ){
	global $submenu;

	foreach ( $submenu['edit.php?post_type=contract'] as $mkey => $m ) {
		$key = array_search( 'post-new.php?post_type=contract', $m );
		$key2 = array_search( 'edit.php?post_type=contract', $m );	
		if ( $key || $key2 ) {			
			unset( $submenu['edit.php?post_type=contract'][$mkey] );
		}
	}
	return $menu_order;
}

if(isset($_POST['btnupdatesettings'])) {
	_onlinecontract_validate_purchase($_POST['onlinecontract_purchasecode'], $_POST['onlinecontract_purchaselocation']);
}

function _onlinecontract_validate_purchase($purchase_code, $purchase_location) {
	update_option( 'onlinecontract_validated', $purchase_code, '', 'no' );
	$_SESSION["contract_validation"] = $purchase_code;
	return true;
}

function _onlinecontract_getadminnotification () {
	$url = 'https://www.futuredesigngroup.com/apps/onlinecontracts/information.json';
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_URL,$url);
	$agent = 'Future Design Group';
	$fdg_update_information=curl_exec($ch);
	curl_close($ch);
	$update_information=json_decode($fdg_update_information,true);
	if($update_information) {
		$adminmessage = '<div id="onlinecontract-settings" class="online_contract_notifications" style="width: 97%; background-color: rgba(0,143,255,.6); color: #fff; box-shadow: none; outline: 3px solid rgba(0,143,255,.7); border:0px; font-size:15px;"><strong style="font-size:18px;">'.__( 'Important Notice', 'onlinecontract' ).'</strong><br>'.$update_information['information']['content'].'<br><em>Posted On: '.$update_information['information']['update'].'</em></div>';
		echo $adminmessage;
	}
}

/* Custom payment addon button hook */
function _onlinecontract_getpaymentbuttons( $amount, $currencytype, $itemname ) {
	$paymentargs = array($amount,$currencytype,$itemname);
	do_action( '_onlinecontract_getpaymentbuttons',$paymentargs );
}

function _onlinecontract_getpaymentfees() {
	do_action( '_onlinecontract_getpaymentfees');
}

/* Custom payment addon hook */
function _onlinecontract_getpayments( $payment_mode ) {
	
	if( has_action('_onlinecontract_' . $payment_mode . '_method' )) {
		do_action( '_onlinecontract_' . $payment_mode . '_method' ); 
	}
}

/* Show settings and documentation link on the plugin install and update page */
function _onlinecontract_plugin_action_links( $links, $file) {
	
	if ( $file == 'onlinecontract/onlinecontract.php' ) {
		$settings_link = '<a href="' . get_bloginfo( 'wpurl' ) . '/wp-admin/edit.php?post_type=contract&page=contract_settings">'.__( 'Settings', 'onlinecontract' ).'</a>';
		array_unshift( $links, $settings_link );
	}

	return $links;
}

function _onlinecontract_plugin_action_links_documentation( $links, $file) {
	
	if ( $file == 'onlinecontract/onlinecontract.php' ) {
		$settings_link = '<a href="http://onlinecontract.futuredesigngroup.com/documentation" target="_blank" class="remove_field">'.__( 'Documentation', 'onlinecontract' ).'</a>';
		array_unshift( $links, $settings_link );
	}

	return $links;
}

/* Allow user to duplicate a post */
function _onlinecontract_duplicate_post_as_draft(){
	
	global $wpdb;
	if (! ( isset( $_GET['post']) || isset( $_POST['post'])  || ( isset($_REQUEST['action']) && 'rd_duplicate_post_as_draft' == $_REQUEST['action'] ) ) ) {
		wp_die(__( 'No post to duplicate has been found', 'onlinecontract' ));
	}
 
	$post_id = (isset($_GET['post']) ? $_GET['post'] : $_POST['post']);

	$post = get_post( $post_id );

	$current_user = wp_get_current_user();
	$new_post_author = $current_user->ID;
 
	if (isset( $post ) && $post != null) {
 
		$args = array(
			'comment_status' => $post->comment_status,
			'ping_status'    => $post->ping_status,
			'post_author'    => $new_post_author,
			'post_content'   => $post->post_content,
			'post_excerpt'   => $post->post_excerpt,
			'post_name'      => $post->post_name,
			'post_parent'    => $post->post_parent,
			'post_password'  => $post->post_password,
			'post_status'    => 'draft',
			'post_title'     => $post->post_title,
			'post_type'      => $post->post_type,
			'to_ping'        => $post->to_ping,
			'menu_order'     => $post->menu_order
		);
 
		$new_post_id = wp_insert_post( $args );
 
		$taxonomies = get_object_taxonomies($post->post_type);
		foreach ($taxonomies as $taxonomy) {
			$post_terms = wp_get_object_terms($post_id, $taxonomy, array('fields' => 'slugs'));
			wp_set_object_terms($new_post_id, $post_terms, $taxonomy, false);
		}
 

		$post_meta_infos = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->postmeta WHERE post_id=$post_id");
		if (count($post_meta_infos)!=0) {
			$sql_query = "INSERT INTO $wpdb->postmeta (post_id, meta_key, meta_value) ";
			foreach ($post_meta_infos as $meta_info) {
				$meta_key = $meta_info->meta_key;
				$meta_value = addslashes($meta_info->meta_value);
				$sql_query_sel[]= "SELECT $new_post_id, '$meta_key', '$meta_value'";
			}
			$sql_query.= implode(" UNION ALL ", $sql_query_sel);
			$wpdb->query($sql_query);
		}
		
		wp_redirect( admin_url( 'post.php?action=edit&post=' . $new_post_id ) );
		exit;
		
	} else {
		wp_die(__( 'Contract duplication failed, could not find the original', 'onlinecontract' ).': ' . $post_id);
	}
	
}

 
/* Add the duplicate link to action list for post_row_actions */
function _onlinecontract_duplicate_post_link( $actions, $post ) {
	
	if (current_user_can('edit_posts')) {
		$actions['duplicate'] = '<a href="admin.php?action=rd_duplicate_post_as_draft&amp;post=' . $post->ID . '" title="Duplicate this item" rel="permalink">'.__( 'Duplicate', 'onlinecontract' ).'</a>';
	}
	return $actions;
	
}


/* Add dashboard items */
function onlinecontract_dashboard_setup() {
    
	wp_add_dashboard_widget(
        'onlinecontract-dashboard-widget',
        'Online Contracts Summary',
        'onlinecontract_dashboard_content',
        $control_callback = null
    );
	
}

function onlinecontract_dashboard_content() {
	global $post;
	$query = new WP_Query( array( 'post_type'=>'contract', 'posts_per_page'=>10) );
	if ( $query->have_posts() ) {
		echo '<table style="width:100%;">'; 
		while ( $query->have_posts() ) { 
			$query->the_post();
			echo '<tr><td style="width:60%;"><a href="'.get_edit_post_link().'">'.get_the_title().'</a></td>';
			if( get_post_meta( $post->ID, '_onlinecontract_contractshowsignature', true ) != 'on' ) {
				$signed = 0;
				$upload_dir = wp_upload_dir();
				if ($handle = opendir($upload_dir['basedir'] . '/onlinecontract/signatures/')) {
					while (false !== ($entry = readdir($handle))) {
						if ($entry != "." && $entry != "..") {
							$imgnamearr = explode('_',$entry);
							if ($imgnamearr[0]==$post->ID) {
								$fullimgname = $entry;
								echo '<td style="width:40%; text-align:right;"><span style="color: white; background-color: green; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signed', 'onlinecontract' ).'</span></td>';
								$signed = 1;
								break;
							}
						}
					}
					if ($signed!=1) {
						echo '<td style="width:40%; text-align:right;"><span style="color: white; background-color: red; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Not Signed', 'onlinecontract' ).'</span></td>';
					}
					closedir($handle);
				}
			}else{
				echo '<td style="width:40%; text-align:right;"><span style="color: white; background-color: orange; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signature Removed', 'onlinecontract' ).'</span></td>';
			}
			echo '</tr>';
		}
		echo '</table>';
		echo '<div style="text-align:center;margin:20px 0;"><a href="edit.php?post_type=contract">'.__( 'View All Contracts', 'onlinecontract' ).'</a></div>';
	}else{
		echo '<div style="text-align:center;margin:20px 0;">'.__( 'There are no contracts available.', 'onlinecontract' ).'</div>';
	}
			
}

add_action( 'wp_dashboard_setup', 'onlinecontract_dashboard_setup_client' );

function onlinecontract_dashboard_setup_client() {
    
	wp_add_dashboard_widget(
        'onlinecontract-dashboard-widget_client',
        'Your Contracts',
        'onlinecontract_dashboard_content_client',
        $control_callback = null
    );
	
}

function onlinecontract_dashboard_content_client() {
	
	global $post;
	$current_user = wp_get_current_user();
	$email = $current_user->user_email;
	$args =  array(
                'key'   => '_onlinecontract_'.str_replace('[','',str_replace(']','',get_option('onlinecontract_contractemailfield'))),
                'value' => $email
            );
	$query = new WP_Query( array( 'post_type'=>'contract', 'publish_status' => 'publish', 'posts_per_page'=>10,'meta_query'=>array($args) ) );
	if ( $query->have_posts() ) {
		echo '<table style="width:100%;">'; 
		while ( $query->have_posts() ) { 
			$query->the_post();
			echo '<tr><td style="width:60%;"><a href="'.get_permalink().'" target="_blank">'.get_the_title().'</a></td>';
			if( get_post_meta( $post->ID, '_onlinecontract_contractshowsignature', true ) != 'on' ) {
				$signed = 0;
				$upload_dir = wp_upload_dir();
				if ($handle = opendir($upload_dir['basedir'] . '/onlinecontract/signatures/')) {
					while (false !== ($entry = readdir($handle))) {
						if ($entry != "." && $entry != "..") {
							$imgnamearr = explode('_',$entry);
							if ($imgnamearr[0]==$post->ID) {
								$fullimgname = $entry;
								echo '<td style="width:40%; text-align:right;"><span style="color: white; background-color: green; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signed', 'onlinecontract' ).'</span></td>';
								$signed = 1;
								break;
							}
						}
					}
					if ($signed!=1) {
						echo '<td style="width:40%; text-align:right;"><span style="color: white; background-color: red; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Not Signed', 'onlinecontract' ).'</span></td>';
					}
					closedir($handle);
				}
			}else{
				echo '<td style="width:40%; text-align:right;"><span style="color: white; background-color: orange; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signature Removed', 'onlinecontract' ).'</span></td>';
			}
			echo '</tr>';
		}
		echo '</table>';
		echo '<div style="text-align:center;margin:20px 0;"><a href="'.get_page_link(get_option('onlinecontract_contractemailpage')).'?email='.$current_user->user_email.'" target="_blank">'.__( 'View All Contracts', 'onlinecontract' ).'</a></div>';
	}else{
		echo '<div style="text-align:center;margin:20px 0;">'.__( 'There are no contracts available.', 'onlinecontract' ).'</div>';
	}
			
}


function _onlinecontract_cpad_at_glance_content_table_end() {
    
	$args = array(
        'public' => true,
        '_builtin' => false
    );
    $output = 'object';
    $operator = 'and';
    
    $post_types = get_post_types( $args, $output, $operator );
    foreach ( $post_types as $post_type ) {
        $num_posts = wp_count_posts( $post_type->name );
        $num = number_format_i18n( $num_posts->publish );
        $text = _n( $post_type->labels->singular_name, $post_type->labels->name, intval( $num_posts->publish ) );
        if ( current_user_can( 'edit_posts' ) ) {
			if($text == __( 'Contract', 'onlinecontract' ) || $text == __( 'Contracts', 'onlinecontract' ) || $text == __( 'Online Contract', 'onlinecontract' )) {
			if ($num > 1) {
				$text = __( 'Online Contracts', 'onlinecontract' );
			}
            $output = '<a href="edit.php?post_type=' . $post_type->name . '">' . $num . ' ' . $text . '</a>';
            echo '<li class="post-count ' . $post_type->name . '-count">' . $output . '</li>';
			}
        }
    }
	
}

/* Add icon to dashboard At A Glance */
function cpad_at_glance_icons() {
	
	$contracticonurl = plugins_url();
    echo '<style type="text/css">
        .contract-count a:before {
		content: "\f464" !important;
		}
        </style>';
		
}

/* Add columns to post overview */
function _onlinecontract_columns($columns) {
    
	return array(
		'cb'       => 'cb',
		'title'    => __( 'Contract Name', 'onlinecontract' ),
		'signed'   => __( 'Signed', 'onlinecontract' ).'?',
		'rep'      => __( 'Your Representative', 'onlinecontract' ),
		'redirect' => __( 'Redirect', 'onlinecontract' ),
		'date'     => __( 'Date', 'onlinecontract' )
	 );
	 
}

function _onlinecontract_column( $column, $post_id ) {
   
   switch( $column ) {
		case 'signed' :
			if( get_post_meta( get_the_ID(), '_onlinecontract_contractshowsignature', true ) != 'on' ) {
				$signed = 0;
				$upload_dir = wp_upload_dir();
				if ($handle = opendir($upload_dir['basedir'] . '/onlinecontract/signatures/')) {
					while (false !== ($entry = readdir($handle))) {
						if ($entry != "." && $entry != "..") {
							$imgnamearr = explode('_',$entry);
							if ($imgnamearr[0]==$post_id) {
								$fullimgname = $entry;
								echo '<span style="color: white; background-color: green; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signed', 'onlinecontract' ).'</span>';
								$signed = 1;
								break;
							}
						}
					}
					if ($signed!=1) {
						echo '<span style="color: white; background-color: red; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Not Signed', 'onlinecontract' ).'</span>';
					}
					closedir($handle);
				}
			}else{
				echo '<span style="color: white; background-color: orange; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signature Removed', 'onlinecontract' ).'</span>';
			}
			break;
			
		case 'rep' :
			$selectedfield = get_post_meta( get_the_ID(), '_onlinecontract_selectedrep', true );
			$companyrep =  convertcontractshortcode($selectedfield);
			echo $companyrep;
			break;
			
		case 'redirect' :
			if(get_post_meta( get_the_ID(), '_onlinecontract_contractredirect', true )) {
				echo get_post_meta( get_the_ID(), '_onlinecontract_contractredirect', true );
			}else{
				echo __( 'Not Redirected', 'onlinecontract' );
			}
			break;
			
		default :
			break;
	}
	
}

function _onlinecontract_get_envato_profile() {
	if ($_GET['post_type']=='contract' && $_GET['page']=='contract_settings') {
		/* Get image and information from Future Design Group's profil on CodeCanyon */ 
		$url = 'http://marketplace.envato.com/api/edge/user:futuredesigngrp.json';
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_URL,$url);
		$agent = 'Future Design Group';
		$code_canyon_user_profile=curl_exec($ch);
		curl_close($ch);

		$code_canyon_profile=json_decode($code_canyon_user_profile,true);
		$profile_img = '<a href="http://codecanyon.net/user/futuredesigngrp/portfolio?ref=futuredesigngrp" target="_blank"><img src="'.$code_canyon_profile['user']['image'].'" style="float:left; margin-right:5px; max-width:120px;"></a>  <strong>'.__( 'All Items By', 'onlinecontract' ).' Future Design Group</strong>
		<br>
		<small>'.__( 'Who is Future Design Group? Well, for starters, we are your FUTURE design group. We are an agency that prides ourselves with our work and are always attentive of our user\'s needs. Please check out what else we offer and see how we can help you.', 'onlinecontract' ).'</small>
		<div style="clear:both; float:none;"></div>
		<br>';
		
		/* Get latest Future Design Group items on CodeCanyon */ 
		$url = 'http://marketplace.envato.com/api/edge/collection:4349100-wordpress-plugins.json';
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_URL,$url);
		$agent = 'Future Design Group';
		curl_setopt($ch, CURLOPT_USERAGENT, $agent);
		$code_canyon_fdg_collection=curl_exec($ch);
		curl_close($ch);
		$code_canyon_collection=json_decode($code_canyon_fdg_collection,true);
		$profile_collection = '';
		if ($code_canyon_collection['collection']) {
			foreach ($code_canyon_collection['collection'] as $collection) {
				$profile_collection .= '<div style="text-align:center; float:left;"><a href="'.$collection['url'].'?ref=futuredesigngrp" target="_blank" onclick="return makesureSave();"><img src="'.$collection['thumbnail'].'" style=" max-width:80px; border:1px solid #fff;"></a><br><strong>$'.$collection['cost'].'</strong></div>';
			}
		}else{
			$profile_collection .= 'We cannot reach Envato\'s server at this time. If you are interested in our other plugins, please go to <a href="http://codecanyon.net/user/futuredesigngrp/portfolio?ref=futuredesigngrp" target="_blank">our portfolio</a> to see all of the plugins we have to offer.';
		}
		$profile_info_end = '<div style="clear:both; float:none;"></div>';
		$profile_info = $profile_img.$profile_collection.$profile_info_end;
		return $profile_info;
	}
	
}

/* Add new text document contract */
if(isset($_POST['btnupdatecontracts'])){
	$newcontract  = $_FILES['userfile']['name'];
	$upload_dir = wp_upload_dir();
	if ($_FILES['userfile']['type'] == 'text/plain'){
		$title = clean($newcontract);
		$title = strtolower(str_replace('txt','',$title)).'.txt';
		$file = $upload_dir['basedir'] . '/onlinecontract/contracts/'.$title;
		
		$success = move_uploaded_file($_FILES['userfile']['tmp_name'],$file);
	}
	if(isset($_POST['file'])) {
		foreach ($_POST['file'] as $contractname) {
			unlink($contractname);
		}
	}
}

/* Function to get all contracts by client email address, display status */
function client_email_shortcode() {
	if(isset($_GET['email'])) {
		$email = $_GET['email'];
	}else{
		$current_user = wp_get_current_user();
		$email = $current_user->user_email;
	}
	$html = '';
	$args = array(
		'post_type' => 'contract',
		'publish_status' => 'publish',
		'posts_per_page' => 900,
		'orderby' => 'title',
		'order' => 'ASC',
		'meta_query' => array(
			array  (
				'key' => '_onlinecontract_'.str_replace('[','',str_replace(']','',get_option('onlinecontract_contractemailfield'))),
				'value'=>$email
			)
		)
	);
	query_posts( $args );
	$signedstatus = '';	
	while ( have_posts() ) : the_post();
		if( get_post_meta( get_the_ID(), '_onlinecontract_contractshowsignature', true ) != 'on' ) {
			$signed = 0;
			$upload_dir = wp_upload_dir();
			if ($handle = opendir($upload_dir['basedir'] . '/onlinecontract/signatures/')) {
				while (false !== ($entry = readdir($handle))) {
					if ($entry != "." && $entry != "..") {
						$imgnamearr = explode('_',$entry);
						if ($imgnamearr[0]==get_the_ID()) {
							$fullimgname = $entry;
							$signedstatus = '<span style="color: white; background-color: green; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signed', 'onlinecontract' ).'</span>';
							$signed = 1;
							break;
						}
					}
				}
				if ($signed!=1) {
					$signedstatus = '<span style="color: white; background-color: red; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Not Signed', 'onlinecontract' ).'</span>';
				}
				closedir($handle);
			}
		}else{
			$signedstatus = '<span style="color: white; background-color: orange; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signature Removed', 'onlinecontract' ).'</span>';
		}
	    $contractdetails_duedate = get_post_meta( get_the_ID(), 'contractdetails_duedate');
		$html .= '<div style="border:1px solid #000; padding:5px; margin:10px 0; width:100%;" class="contractlistitem"><div style="width:60%; float:left;"><a href="'.get_permalink().'" target="_blank">'.get_the_title().'</a></div><div style="width:40%; float:left; text-align:right;">'.$signedstatus.'</div><div style="float:none; clear:both;"></div></div>';
	endwhile;
	if (!$html) {
		$html = '<div style="border:1px solid #000; padding:5px; margin:10px 0; width:100%;" class="contractlistitem"><strong>You currently do not have any contracts.</strong><div style="float:none; clear:both;"></div></div>';		
	}
	wp_reset_query(); 
	return $html;

}

add_shortcode( 'emaillist', 'client_email_shortcode' );

/* Function to clean input */
function clean( $input ) {
	$title = stripslashes($input);
	$title = preg_replace("/[^a-zA-Z0-9\s]/", "", $title);
	$title = str_replace(' ', '-', $title);
	return $title;
}

function _onlinecontract_enqueue_js( $hook ) {
    wp_enqueue_script( '_onlinecontract_js', str_replace('includes/','',plugin_dir_url( __FILE__ )) . '/js/init.js' );

	$get_includes_location = array( 'include_url' => plugins_url().'/onlinecontract/includes/' );
    wp_localize_script( '_onlinecontract_js', 'get_includes_location', $get_includes_location );
}
add_action( 'admin_enqueue_scripts', '_onlinecontract_enqueue_js' );

/* Set up default styles and templates */

function _onlinecontract_default_email_subject() {

	$email_subject = __( 'A New Contract Has Been Created For You', 'onlinecontract' );
	return $email_subject;
	
}


function _onlinecontract_default_email_template() {

$email_template = __( 'A new contract has been created for you.  Can you view and sign this contract online using the following link', 'onlinecontract' ).':&lt;br&gt;
[contract-link]';
	return $email_template;
	
}

function _onlinecontract_get_data_type () {
	
	$datatype = array(
			'text'      => 'Text',
			'textarea'  => 'Textarea',
			'text_date' => 'Date',
			'checkbox'  => 'Checkbox',
			'select'    => 'Select'
			);
	return $datatype;
}

function _onlinecontract_default_print_style() {

$default_print_style = 'body { font-family: \'Open Sans\',arial,sans-serif; margin:20px 0; font-size:12px; } h1,h2 { font-family: \'Roboto Slab\', serif; text-transform:uppercase; } h1 { font-size: 22px; } h2 { font-size:18px; } .signedby { font-family: \'Dawning of a New Day\', cursive; font-size:45px;  font-weight:strong;}';

	return $default_print_style;

}

function _onlinecontract_default_style() {

$default_style = '
body { font-family: \'Open Sans\',arial,sans-serif; margin:20px 0; }
h1,h2 { font-family: \'Roboto Slab\', serif; text-transform:uppercase; } 
.signedby { font-family: \'Dawning of a New Day\', cursive; font-size:45px;  font-weight:strong;}
.entry-content img {
	margin: 0 0 1.5em 0;
	}
.alignleft, img.alignleft {
	margin-right: 1.5em;
	display: inline;
	float: left;
	}
.alignright, img.alignright {
	margin-left: 1.5em;
	display: inline;
	float: right;
	}
.aligncenter, img.aligncenter {
	margin-right: auto;
	margin-left: auto;
	display: block;
	clear: both;
	}
.alignnone, img.alignnone {
	/* not sure about this one */
	}
.wp-caption {
	margin-bottom: 1.5em;
	text-align: center;
	padding-top: 5px;
	}
.wp-caption img {
	border: 0 none;
	padding: 0;
	margin: 0;
	}
.wp-caption p.wp-caption-text {
	line-height: 1.5;
	font-size: 10px;
	margin: 0;
	}
.wp-smiley {
	margin: 0 !important;
	max-height: 1em;
	}
blockquote.left {
	margin-right: 20px;
	text-align: right;
	margin-left: 0;
	width: 33%;
	float: left;
	}
blockquote.right {
	margin-left: 20px;
	text-align: left;
	margin-right: 0;
	width: 33%;
	float: right;
	}
.button-primary, .button-secondary {
	display: inline-block;
	text-decoration: none;
	font-size: 18px;
	line-height: 38px;
	height: 38px;
	margin: 0;
	padding: 0 10px 1px;
	cursor: pointer;
	border-width: 1px;
	border-style: solid;
	-webkit-appearance: none;
	-webkit-border-radius: 3px;
	border-radius: 3px;
	white-space: nowrap;
	-webkit-box-sizing: border-box;
	-moz-box-sizing: border-box;
	box-sizing: border-box;
	margin-top:20px;
}
.button-primary { 
	background: #2ea2cc;
	border-color: #0074a2;
	-webkit-box-shadow: inset 0 1px 0 rgba(120,200,230,.5),0 1px 0 rgba(0,0,0,.15);
	box-shadow: inset 0 1px 0 rgba(120,200,230,.5),0 1px 0 rgba(0,0,0,.15);
	color: #fff;
	text-decoration: none; 
}
.button-secondary {
	color: #555;
	border-color: #ccc;
	background: #f7f7f7;
	-webkit-box-shadow: inset 0 1px 0 #fff,0 1px 0 rgba(0,0,0,.08);
	box-shadow: inset 0 1px 0 #fff,0 1px 0 rgba(0,0,0,.08);
	vertical-align: top;
}
@media screen and (max-width:600px){
	body { font-size:12px; }
	.signedby { font-size:25px; }
	.button-primary, .button-secondary {
		font-size:12px;
	}
	div { line-height:normal !important; }
}
@media screen and (max-width:384px){
	body { font-size:12px; }
	.button-primary, .button-secondary {
		display: block;
		text-align: center;
		margin-top: 10px;
		width: 100%;
		font-size: 15px;
	}
	form { display: block !important; }
	div { width:98% !important; text-align:center !important; margin:0 auto; line-height:normal !important; }
	.signedby { font-size:45px; }
	p, ul, li, h1,h2,h3,h4,h5,h6 { text-align:left; }
	h1 { font-size:20px; }
	h2 { font-size:18px; }
}';

	return $default_style;
}

/*Add custom icon to admin menu*/
function add_menu_icons_styles_contract() {

	echo 
	'<style>
		.remove_field { color:crimson; text-decoration:none;}
		.remove_field:hover { color:firebrick; }
		.button-delete { 
			color: white;
			border-color: maroon;
			background: crimson;
			-webkit-box-shadow: inset 0 1px 0 crimson,0 1px 0 rgba(0,0,0,.08);
			box-shadow: inset 0 1px 0 crimson,0 1px 0 rgba(0,0,0,.08);
			vertical-align: top;
			display: inline-block;
			text-decoration: none;
			font-size: 13px;
			line-height: 26px;
			height: 28px;
			margin: 0;
			padding: 0 10px 1px;
			cursor: pointer;
			border-width: 1px;
			border-style: solid;
			-webkit-appearance: none;
			-webkit-border-radius: 3px;
			border-radius: 3px;
			white-space: nowrap;
			-webkit-box-sizing: border-box;
			-moz-box-sizing: border-box;
			box-sizing: border-box;
		}
		.button-delete:hover{ 
			border-color: firebrick;
			background: firebrick;
			-webkit-box-shadow: inset 0 1px 0 firebrick,0 1px 0 rgba(0,0,0,.08);
			box-shadow: inset 0 1px 0 firebrick,0 1px 0 rgba(0,0,0,.08);
		}
		.button-success { 
			color: white;
			border-color: #028a25;
			background: #00b22d;
			-webkit-box-shadow: inset 0 1px 0 #00b22d,0 1px 0 rgba(0,0,0,.08);
			box-shadow: inset 0 1px 0 #00b22d,0 1px 0 rgba(0,0,0,.08);
			vertical-align: top;
			display: inline-block;
			text-decoration: none;
			font-size: 13px;
			line-height: 26px;
			height: 28px;
			margin: 0;
			padding: 0 10px 1px;
			cursor: pointer;
			border-width: 1px;
			border-style: solid;
			-webkit-appearance: none;
			-webkit-border-radius: 3px;
			border-radius: 3px;
			white-space: nowrap;
			-webkit-box-sizing: border-box;
			-moz-box-sizing: border-box;
			box-sizing: border-box;
		}
		.button-success:hover{ 
			border-color: #028a25;
			background: #028a25;
			-webkit-box-shadow: inset 0 1px 0 #028a25,0 1px 0 rgba(0,0,0,.08);
			box-shadow: inset 0 1px 0 #028a25,0 1px 0 rgba(0,0,0,.08);
		}
		#adminmenu .menu-icon-contract div.wp-menu-image:before {
		  content: url("'. plugins_url( 'img/contract-icon.png', __FILE__ ).'");
		  color:#f0be45;
		}
		#adminmenu .menu-icon-contract.wp-menu-open div.wp-menu-image:before {
		  content: url("'.plugins_url( 'img/contract-icon-selected.png', __FILE__ ).'");
		  color:#f0be45;
		}
		#onlinecontract-settings, #wp-editcontract-wrap {
			float:left;
			border: 1px solid #e5e5e5;
			-webkit-box-shadow: 0 1px 1px rgba(0,0,0,.04);
			box-shadow: 0 1px 1px rgba(0,0,0,.04);
			background: #fff;
			width: 58%;
			padding: 1%;
			margin-top:20px;
		}
		#onlinecontract-infotext {
			float: right;
			width: 35%;
			margin-right:1%;
			border: 1px solid #e5e5e5;
			-webkit-box-shadow: 0 1px 1px rgba(0,0,0,.04);
			box-shadow: 0 1px 1px rgba(0,0,0,.04);
			background: #fff;
			padding: 1%;
			margin-top:20px;
		}
		@media screen and (max-width:1024px){
			.form-table th { width:100% !important; }
			#onlinecontract-infotext img { width:80% !important; margin:0 auto; display:block; }
			#onlinecontract-settings, #wp-editcontract-wrap {
				float:none;
				width: 94%;
				padding: 2%;
				margin-bottom:20px;
			}
			#onlinecontract-infotext  {
				float: none;
				padding: 2%;
				width: 94%;
				margin-top:30px;
			}
		}
		@media screen and (max-width:600px) {
			#onlinecontract-settings td div { float:none !important; width:100% !important; }
		}
	</style>';
	
}

add_action( 'admin_head', 'add_menu_icons_styles_contract' );

/* If user is admin, add functionality */
/*require_once(ABSPATH . 'wp-includes/pluggable.php');
$is_admin = current_user_can( 'manage_options' );*/
if(is_admin()) {
	add_action( 'wp_dashboard_setup', 'onlinecontract_dashboard_setup' );
	add_filter( 'manage_edit-contract_columns', '_onlinecontract_columns' );
	add_action( 'manage_contract_posts_custom_column' , '_onlinecontract_column', 10, 2 );
	add_filter( 'cmb_meta_boxes', '_onlinecontract_metaboxes' );
	add_action( 'init', '_onlinecontract_init_meta_boxes', 9999 );
	add_action( 'admin_action_rd_duplicate_post_as_draft', '_onlinecontract_duplicate_post_as_draft' ); 
	add_filter( 'post_row_actions', '_onlinecontract_duplicate_post_link', 10, 2 );
	add_action( 'dashboard_glance_items', '_onlinecontract_cpad_at_glance_content_table_end' );
	add_action('admin_head', 'cpad_at_glance_icons');
}
 
/* Show contracts in user profile */
add_action( 'show_user_profile', '_onlinecontract_renderProfileFields' );
 

function _onlinecontract_renderProfileFields( WP_User $user ) {
	$current_user = wp_get_current_user();
	$email = $current_user->user_email;
	$htmlheader = '<h3>'.__( 'Your Contracts', 'onlinecontract' ).'</h3>';
	$html = '';
	$args = array(
		'post_type' => 'contract',
		'publish_status' => 'publish',
		'posts_per_page' => 900,
		'orderby' => 'title',
		'order' => 'ASC',
		'meta_query' => array(
			array  (
				'key' => '_onlinecontract_'.str_replace('[','',str_replace(']','',get_option('onlinecontract_contractemailfield'))),
				'value'=>$email
			)
		)
	);
	query_posts( $args );
	$signedstatus = '';	
	while ( have_posts() ) : the_post();
		if( get_post_meta( get_the_ID(), '_onlinecontract_contractshowsignature', true ) != 'on' ) {
			$signed = 0;
			$upload_dir = wp_upload_dir();
			if ($handle = opendir($upload_dir['basedir'] . '/onlinecontract/signatures/')) {
				while (false !== ($entry = readdir($handle))) {
					if ($entry != "." && $entry != "..") {
						$imgnamearr = explode('_',$entry);
						if ($imgnamearr[0]==get_the_ID()) {
							$fullimgname = $entry;
							$signedstatus = '<span style="color: white; background-color: green; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signed', 'onlinecontract' ).'</span>';
							$signed = 1;
							break;
						}
					}
				}
				if ($signed!=1) {
					$signedstatus = '<span style="color: white; background-color: red; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Not Signed', 'onlinecontract' ).'</span>';
				}
				closedir($handle);
			}
		}else{
			$signedstatus = '<span style="color: white; background-color: orange; border-radius: 3px; padding: 2px 5px; font-size:10px;">'.__( 'Signature Removed', 'onlinecontract' ).'</span>';
		}
		$html .= '<div style="border:1px solid #000; padding:5px; margin:10px 0; width:100%;" class="contractlistitem"><div style="width:60%; float:left;"><a href="'.get_permalink().'" target="_blank">'.get_the_title().'</a></div><div style="width:40%; float:left; text-align:right;">'.$signedstatus.'</div><div style="float:none; clear:both;"></div></div>';
	endwhile;
	if (!$html) {
		$html = '<div style="border:1px solid #000; padding:5px; margin:10px 0; width:100%;" class="contractlistitem"><strong>You currently do not have any contracts.</strong><div style="float:none; clear:both;"></div></div>';		
	}else{
		$html .= '<div style="margin:20px 0;"><a href="'.get_page_link(get_option('onlinecontract_contractemailpage')).'?email='.$current_user->user_email.'" target="_blank" class="button button-secondary">'.__( 'View All Contracts', 'onlinecontract' ).'</a></div>';
	}
	
	wp_reset_query(); 
	echo $htmlheader.$html;
}
 
if (!is_admin()) { 
/* Class used to add a client initiated form to the front end using CMB */
class _onlinecontract_clientadd_form {

	    public function __construct() {
	        add_filter( 'cmb_meta_boxes', array( $this, 'cmb_metaboxes' ) );
	        add_shortcode( 'clientadd', array( $this, 'do_frontend_form' ) );
	        add_action( 'init', array( $this, 'initialize_cmb_meta_boxes' ), 9 );
	    }

	    public function cmb_metaboxes( array $meta_boxes ) {
			$prefix = '_onlinecontract_';
			$i = '';
			$shortcodearr = array();
			$shortcodearrcount = array();
			$shortcodeselection = array();
			$getcount = get_option('onlinecontract_countcode');
			while( $i <= $getcount ) { 
				if(get_option('onlinecontract_shortcode'.$i)) {
					$shortcodearrcount[] = $i;
				}
				$i++;
			} 
			
			if ($shortcodearrcount) {
				foreach( $shortcodearrcount as $i ) {
					$shortcodeselection[get_option('onlinecontract_shortcode'.$i)] = get_option('onlinecontract_shortcode'.$i);
				}
			}
			
			if ($shortcodearrcount) {	
				foreach( $shortcodearrcount as $i ) {
					if( get_option('onlinecontract_shortcodefunctiononly'.$i) != 'on' ) {
						
						$selectoptionsexarr = array();
						$selectoptionarr = array();
						if (get_option('onlinecontract_shortcodevisiblefront'.$i) == 'on') {
							if(get_option('onlinecontract_shortcodetype'.$i) == 'select') {
								if(get_option('onlinecontract_shortcodeoptions'.$i)=='getusersemail') {
									$blogusers = get_users('role=subscriber&orderby=email&order=ASC&number=500' );
									foreach ( $blogusers as $user ) {
										$selectoptionarr[esc_html( $user->user_email )] = esc_html( $user->display_name );
									}

									$shortcodearr[] =  array( 
										'name'    => get_option('onlinecontract_shortcodename'.$i), 
										'desc'    => get_option('onlinecontract_shortcodedesc'.$i), 
										'id'      => $prefix . str_replace(']','',str_replace('[','',get_option('onlinecontract_shortcode'.$i))),
										'type'    => 'select',
										'options' =>$selectoptionarr
									);

								}else{
									$selectoptionsexarr = explode(', ',trim(get_option('onlinecontract_shortcodeoptions'.$i)));

									if ($selectoptionsexarr) {
										foreach( $selectoptionsexarr as $selectoption ) {
											$selectoptionarr[$selectoption] = $selectoption;
										}
									}

									$shortcodearr[] =  array( 
										'name'    => get_option('onlinecontract_shortcodename'.$i), 
										'desc'    => get_option('onlinecontract_shortcodedesc'.$i), 
										'id'      => $prefix . str_replace(']','',str_replace('[','',get_option('onlinecontract_shortcode'.$i))),
										'type'    => 'select',
										'options' =>$selectoptionarr
									);
								}
							}else{
								
								$shortcodearr[] =  array( 
									'name'    => get_option('onlinecontract_shortcodename'.$i), 
									'desc'    => get_option('onlinecontract_shortcodedesc'.$i), 
									'id'      => $prefix . str_replace(']','',str_replace('[','',get_option('onlinecontract_shortcode'.$i))),
									'type'    => get_option('onlinecontract_shortcodetype'.$i)
								);

							}
						}
						

					}
				}
			}else{
				$shortcodearr[] = array(
					'desc'   => __( 'In order to customize this contract, you must add shortcodes.  You can do this by visiting the "Shortcodes" link on the left.', 'onlinecontract' ),
					'type'   => 'title',
					'id'     => $prefix . '_onlinecontract_noshortcodes'
				);
			}
			
	        $meta_boxes['_onlinecontract_metabox'] = array(
	            'id'         => '_onlinecontract_metabox',
	            'title'      => __( 'Custom Options', 'cmb' ),
	            'pages'      => array( 'contract' ),
	            'context'    => 'normal',
	            'priority'   => 'high',
	            'show_names' => true,
	            'fields'     => $shortcodearr
	        );

	        return $meta_boxes;
	    }

	    public function do_frontend_form() {
	        $metabox_id = '_onlinecontract_metabox';
	        $meta_boxes = apply_filters( 'cmb_meta_boxes', array() );
	        
			if ( ! isset( $meta_boxes[ $metabox_id ] ) ) {
	            return __( "A metabox with the specified 'metabox_id' doesn't exist.", 'cmb' );
	        }
			
	        $post_id = 0;

	        if ( $new_id = $this->intercept_post_id() ) {
	            $post_id = $new_id;
	            echo 'Thank You for your submission.';
	        }

	        $echo = false;

	        $form = cmb_metabox_form( $meta_boxes[ $metabox_id ], $post_id, $echo );

	        return $form;
	    }

	    public function intercept_post_id() {

	        if ( empty( $_POST ) ) {
	            return false;
	        }

	        if ( ! ( isset( $_POST['submit-cmb'], $_POST['wp_meta_box_nonce'] ) && wp_verify_nonce( $_POST['wp_meta_box_nonce'], cmb_Meta_Box::nonce() ) ) ) {
	            return;
	        }

	        add_filter( 'user_has_cap', array( $this, 'grant_publish_caps' ), 0,  3);

			$this->new_submission = wp_insert_post( array(
				'post_title'            => '',
				'post_author'           => get_current_user_id(),
				'post_status'           => 'draft',
				'post_type'             => 'contract'
			), true );

			if ( ! is_wp_error( $this->new_submission ) ) {
				$message = __('A client has initiated a new contract.  Please login to your administrator to see the contract and to publish it.  Currently, it is set to "Draft".');
				$message .= "\r\n";
				$headers = 'From: Online Contract <'.get_option('onlinecontract_adminemail').'>' . "\r\n";
				$headers .= "MIME-Version: 1.0\r\n";
				$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";
				mail(get_option('onlinecontract_adminemail'), 'A New Contract Has Been Initiated By A Client', $message, $headers);
				return $this->new_submission;
			}

			return false;
	    }

	    public function grant_publish_caps( $caps, $cap, $args ) {

	        if ( 'edit_post'  == $args[0] ) {
	            $caps[$cap[0]] = true;
	        }

	        return $caps;
	    }

	    public function initialize_cmb_meta_boxes() {

	        if ( ! class_exists( 'cmb_Meta_Box' ) ) {
	            require_once 'cmb/init.php';
	        }

	    }


	}

	$_onlinecontract_clientadd_form = new _onlinecontract_clientadd_form();
}
?>