<?php if( is_admin()){
	/*Add PayPal settings to admin submenu*/
	add_action('admin_menu', '_onlinecontract_paypalsettings');
	function _onlinecontract_paypalsettings() {
		add_submenu_page( 'edit.php?post_type=contract',  'Paypal&trade;',  'Paypal&trade;', 'manage_options', 'paypal_settings', 'paypal_settings' ); 
	}



	/*Populate PayPal settings page*/

	function paypal_settings() { ?>



		<div class="wrap">

			<h2>PayPal&trade; <?php _e( 'Settings', 'onlinecontract' ); ?></h2>

			<?php _onlinecontract_getadminnotification(); ?>

		</div>

		

	<?php 

	

		echo _onlinecontract_getpayments('paypal');

	

	}

	

	function _onlinecontract_paypal_method() {

	

		/*Get values from previously submitted options*/

		$_onlinecontract_paypalcode = get_option('onlinecontract_contractpaypalcode');

		

		$_onlinecontract_paypalfee = get_option('onlinecontract_contractpaypalfee');

		

		$_onlinecontract_paypalbuttonlabel = get_option('onlinecontract_contractpaypallabel'); 

		

		?>

		

		<div id="onlinecontract-settings">

			<p><?php _e( 'If you are wanting to use PayPal as a integrated method of Payment after a contract is signed, use the following section to provide a bit of information for our plugin to use, otherwise leave this section blank.', 'onlinecontract' ); ?></p>	

			<form action="options.php" method="post" name="options" enctype="multipart/form-data">

				<?php echo wp_nonce_field('update-options'); ?>

				<table class="form-table" width="100%" cellpadding="10">

					<tr>

						<th><label for="onlinecontract_contractpaypalcode">PayPal <?php _e( 'Email Address', 'onlinecontract' ); ?></label></th>

						<td><input type="text" name="onlinecontract_contractpaypalcode" id="onlinecontract_contractpaypalcode" value="<?php echo $_onlinecontract_paypalcode; ?>" size="30" style="width:97%;"><br><small><?php _e( 'Enter the name of your company that will display on the contract.', 'onlinecontract' ); ?></small></td>

					</tr>

					<tr>

						<th><label for="onlinecontract_contractpaypalfee"><?php _e( 'Charge A Fee', 'onlinecontract' ); ?></label></th>

						<td><input type="text" name="onlinecontract_contractpaypalfee" id="onlinecontract_contractpaypalfee" value="<?php echo $_onlinecontract_paypalfee; ?>" size="30" style="width:50%;"><br><small>You can charge a fee to use Paypal (ex: 2.50 or 2.9%), however, please <a href="https://www.paypal.com/webapps/mpp/ua/useragreement-full#4" target="_blank" onclick="return makesureSave();">verify</a> with your country's TOS to make sure this is legal in your country.</small></td>

					</tr>

					<tr>

						<th><label for="onlinecontract_contractpaypallabel">PayPal <?php _e( 'Button Label', 'onlinecontract' ); ?></label></th>

						<td><input type="text" name="onlinecontract_contractpaypallabel" id="onlinecontract_contractpaypallabel" value="<?php echo $_onlinecontract_paypalbuttonlabel; ?>" size="30" style="width:97%;"><br><small>Enter the label that will appear on the button.</small></td>

					</tr>

				</table>

				<input type="hidden" name="action" value="update" />

				<input type="hidden" name="page_options" value="onlinecontract_contractpaypalcode,onlinecontract_contractpaypalfee,onlinecontract_contractpaypallabel" />

				<div style="float:right; padding-top:8px; width: 40%; text-align: right;"><?php _e( 'Version', 'onlinecontract' ); ?> <?php echo _onlinecontract_version_num; ?> </div>

				<input type="submit" name="btnupdatepaypal" id="btnupdatepaypal" value="<?php _e( 'Update Settings', 'onlinecontract' ); ?>" class="button-primary" />

			</form>

		</div>

		

		<div id="onlinecontract-infotext">

			<h3>PayPal <?php _e( 'Payment Integration', 'onlinecontract' ); ?></h3>

			<hr>

			<p><?php _e( 'Add a payment option to your contracts using PayPal.  Setup your PayPal button using the options to the left. Once you configure the options, a PayPal button will be added to your contract automatically.', 'onlinecontract' ); ?></p>

			<h3><?php _e( 'Need to Create a Account', 'onlinecontract' ); ?>?</h3>

			<hr>

			<p><?php _e( 'If you would like to use the payment option but do not have a PayPal account, you can join on their website.  It is free and easy to get started.  Visit <a href="http://paypal.com" target="_blank" onclick="return makesureSave();">www.paypal.com</a> to see the benefits of signing up and to create an account.', 'onlinecontract' ); ?></p>

			<h3><?php _e( 'Need More Payment Methods', 'onlinecontract' ); ?>?</h3>

			<hr>

			<p><?php _e( 'Please see our <a href="http://codecanyon.net/user/futuredesigngrp/portfolio?ref=futuredesigngrp" onclick="return makesureSave();" target="_blank">portfolio</a>  for more payment processing plugins built by Future Design Group for our WP Online Contract plugin.', 'onlinecontract' ); ?></p>

		</div>

		

		<?php

		

	}

	

	add_action( '_onlinecontract_paypal_method', '_onlinecontract_paypal_method' );

}



/*Add PayPal button to contract and place custom label*/

function _onlinecontract_paypal_button($paymentargs) { 

	

	if(get_option('onlinecontract_contractpaypalfee')) {

		if (strpos(get_option('onlinecontract_contractpaypalfee'), '%') !== false) {

			$percentage = str_replace('%','',get_option('onlinecontract_contractpaypalfee'));

			$percentage = $paymentargs[0] * ($percentage/100);

			$paypal_fee = $percentage;

			$amount = $paymentargs[0] + $paypal_fee;

		}else{

			$paypal_fee= get_option('onlinecontract_contractpaypalfee');

			$amount = $paymentargs[0]+ $paypal_fee;

		}

	}else{

		$amount = $paymentargs[0];

	}

	$amount = number_format((float)$amount, 2, '.', '');

	echo '<button type="button" class="button-primary" onclick="window.open(\'https://www.paypal.com/cgi-bin/webscr?business='.get_option('onlinecontract_contractpaypalcode').'&amp;cmd=_xclick&amp;currency_code='.$paymentargs[1].'&amp;amount='.$amount.'&amp;item_name='.$paymentargs[2].'\',\'_blank\')">'.get_option('onlinecontract_contractpaypallabel').'</button>';



}



add_filter( '_onlinecontract_getpaymentbuttons', '_onlinecontract_paypal_button' );



/*Add PayPal fee is user adds one*/

function _onlinecontract_paypal_fee() { 

	

	if(get_option('onlinecontract_contractpaypalfee')) {

		if (strpos(get_option('onlinecontract_contractpaypalfee'), '%') === false) {

			$currencysymbol = get_option('onlinecontract_contractcurrency');

		}

		echo 'There is a '.$currencysymbol.get_option('onlinecontract_contractpaypalfee').' handling fee to use PayPal to pay your contract online.<br>';

	}

	

}



add_filter( '_onlinecontract_getpaymentfees', '_onlinecontract_paypal_fee' );

?>