<?php if(_onlinecontract_validate_purchase(get_option('onlinecontract_purchasecode'), get_option('onlinecontract_purchaselocation'))) { 

	if( is_admin()){

		

		/*Add Templates to admin submenu*/

		add_action('admin_menu', '_onlinecontract_templates');



		function _onlinecontract_templates() {



			add_submenu_page( 'edit.php?post_type=contract',  __( 'Other Templates', 'onlinecontract' ),  __( 'Other Templates', 'onlinecontract' ), 'manage_options', 'templates', 'templates' ); 

			

		}



		/*Populate Templates page*/

		function templates() { 

		

		/*Get values from previously submitted options*/

		

		$_onlinecontract_emailtemplate = get_option('onlinecontract_emailtemplate');

		

		$_onlinecontract_emailtemplatesubject = get_option('onlinecontract_emailtemplatesubject');

		

		$_onlinecontract_styletemplate = get_option('onlinecontract_styletemplate');

		

		$_onlinecontract_printstyletemplate = get_option('onlinecontract_printstyletemplate');

		

		if ( !$_onlinecontract_styletemplate ) {

		

			$_onlinecontract_styletemplate = _onlinecontract_default_style();

			

		}

		

		if ( !$_onlinecontract_printstyletemplate ) {

		

			$_onlinecontract_printstyletemplate = _onlinecontract_default_print_style();

			

		}

		

		if( !$_onlinecontract_emailtemplatesubject ) {

			

			$_onlinecontract_emailtemplatesubject = _onlinecontract_default_email_subject();

		}

		

		if( !$_onlinecontract_emailtemplate ) {

			

			$_onlinecontract_emailtemplate = _onlinecontract_default_email_template();

		}

		

		?>



			<div class="wrap">

				<h2><?php _e( 'Templates', 'onlinecontract' ); ?></h2>

				<?php _onlinecontract_getadminnotification(); ?>

				<form action="options.php" method="post" name="options" enctype="multipart/form-data">

					<?php echo wp_nonce_field('update-options'); ?>

					<div id="onlinecontract-settings" style="width:97%;">

						<h3><?php _e( 'Contract', 'onlinecontract' ); ?> CSS</h3>

						<hr>

						<textarea name="onlinecontract_styletemplate" id="onlinecontract_styletemplate" style="width:100%; height:450px;" required><?php echo $_onlinecontract_styletemplate; ?></textarea>

						<br><small><?php _e( 'You can change the default style of the plugin by modifying the stylesheet above. Leave as is if you want to use the default style.', 'onlinecontract' ); ?><br>

						<?php _e( 'Only change what you need, as most of this is WP specific and it helps the style of your contract and is responsive.', 'onlinecontract' ); ?> <span style="color:red;"><strong><?php _e( 'Modify at your own risk.', 'onlinecontract' ); ?></strong></span></small>					

					</div>

					<div id="onlinecontract-settings" style="width:97%;">

						<h3><?php _e( 'Contract Print', 'onlinecontract' ); ?> CSS</h3>

						<hr>

						<textarea name="onlinecontract_printstyletemplate" id="onlinecontract_printstyletemplate" style="width:100%; height:200px;" required><?php echo $_onlinecontract_printstyletemplate; ?></textarea>

						<br><small><?php _e( 'You can change the default print style of the plugin by modifying the stylesheet above. Leave as is if you want to use the default print style. Also, keep in mind this will only effect the browser print ability.  Styling is not allowed with the PDF as it is preset.', 'onlinecontract' ); ?><br>

						<span style="color:red;"><strong><?php _e( 'In order to work properly, this template MUST BE ON ONE LINE. Modify at your own risk.', 'onlinecontract' ); ?></strong></span></small>

					</div>

					<div id="onlinecontract-infotext">

						<h3>Contract Shortcodes</h3>

						<hr>

						<div style="overflow-y:scroll; height:625x;">

							<?php 

								$shortcodearr = _onlinecontract_getallshortcodes();

								if($shortcodearr) {

									foreach ($shortcodearr as $shortcode) {

										echo '<p><strong>'.$shortcode['shortcode'].'</strong>';

										if($shortcode['isfunction']=='') {

											echo '<br>'.$shortcode['description'].'</p>';

										}else{

											echo '<br><em>'.__( 'Used as a function').'</em> ( <strong>'.$shortcode['functionstring'].'</strong> )</p>';

										}

									}

								}else{

									_e( 'In order to customize this contract, you must add shortcodes.  You can do this by visiting the "Shortcodes" link on the left.', 'onlinecontract' );

								}

							?>

						</div>

					</div>

					<div id="onlinecontract-settings">

						<h3><?php _e( 'Notification Email Template', 'onlinecontract' ); ?></h3>

						<hr>

						<table class="form-table" width="100%" cellpadding="10">

							<tr>

								<th><label for="onlinecontract_emailtemplatesubject"><?php _e( 'Email Subject', 'onlinecontract' ); ?></label></th>

								<td><input type="text" name="onlinecontract_emailtemplatesubject" id="onlinecontract_emailtemplatesubject" value="<?php echo $_onlinecontract_emailtemplatesubject; ?>" style="width:50%;"><br><small><?php _e( 'Enter the subject for your contract template.', 'onlinecontract' ); ?></small></td>

							</tr>

						</table>

						<textarea name="onlinecontract_emailtemplate" id="onlinecontract_emailtemplate" style="width:100%; height:450px;" required><?php echo $_onlinecontract_emailtemplate; ?></textarea>

						<br><small><?php _e( 'If you wish to change the notification email, please enter it here using HTML code. Use the shortcode <strong>[contract-link]</strong> to add a link back to the contract. You can use your custom shortcodes on the right to customize this notification template.', 'onlinecontract' ); ?></small>

			<br>

			<br>

			<small><?php _e( 'You can use the following HTML code for common elements', 'onlinecontract' ); ?>:<br>&lt;br&gt; <?php _e( 'single line break', 'onlinecontract' ); ?>, &lt;p&gt;<?php _e( 'paragraph', 'onlinecontract' ); ?>&lt;/p&gt;, <strong>&lt;strong&gt;<?php _e( 'bold', 'onlinecontract' ); ?>&lt;strong&gt;</strong>, <em>&lt;em&gt;<?php _e( 'italic', 'onlinecontract' ); ?>&lt;em&gt;</em></small></td>

					</div>

					<div id="onlinecontract-settings" style="width:97%;">

						<input type="hidden" name="action" value="update" />

						<input type="hidden" name="page_options" value="onlinecontract_styletemplate,onlinecontract_printstyletemplate,onlinecontract_emailtemplatesubject,onlinecontract_emailtemplate" />

						<div style="float:right; padding-top:8px; width: 40%; text-align: right;"><?php _e( 'Version', 'onlinecontract' ); ?> <?php echo _onlinecontract_version_num; ?> </div>

						<input type="submit" name="btnupdatepaypal" id="btnupdatepaypal" value="<?php _e( 'Update', 'onlinecontract' ); ?>" class="button-primary" />

					</div>

				</form>

			</div>

		<?php 



		}

		

	}

} ?>